"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.guard = void 0;
const symbols_1 = require("./symbols");
const utils_1 = require("./utils");
function guard(name, fn, handleOptions, defaultOptions = {}) {
    function getFnWithErrors(options) {
        return (value, path = []) => {
            var _a, _b, _c, _d, _e;
            const data = fn(value, options);
            if (!(0, utils_1.isValid)(data) && value === undefined && ((handleOptions === null || handleOptions === void 0 ? void 0 : handleOptions.default) !== undefined || (options === null || options === void 0 ? void 0 : options.default) !== undefined)) {
                return { valid: true, data: (_a = options === null || options === void 0 ? void 0 : options.default) !== null && _a !== void 0 ? _a : handleOptions === null || handleOptions === void 0 ? void 0 : handleOptions.default, errors: [] };
            }
            if (!(0, utils_1.isValid)(data) || !((_b = handleOptions === null || handleOptions === void 0 ? void 0 : handleOptions.validate) !== null && _b !== void 0 ? _b : utils_1.trueFn)(data, options)) {
                return {
                    valid: false,
                    data: undefined,
                    errors: [
                        {
                            message: `vality.${name}.base`,
                            path,
                            options,
                            value,
                        },
                    ],
                };
            }
            if (!((_c = options.validate) !== null && _c !== void 0 ? _c : utils_1.trueFn)(data)) {
                return {
                    valid: false,
                    data: undefined,
                    errors: [
                        {
                            message: `vality.${name}.custom`,
                            path,
                            options,
                            value,
                        },
                    ],
                };
            }
            const transformedData = ((_d = options.transform) !== null && _d !== void 0 ? _d : utils_1.identity)(((_e = handleOptions === null || handleOptions === void 0 ? void 0 : handleOptions.transform) !== null && _e !== void 0 ? _e : utils_1.identity)(data));
            if (handleOptions === undefined)
                return { valid: true, data: transformedData, errors: [] };
            const keysWithError = Object.keys(options).filter(k => k !== "transform" &&
                k !== "validate" &&
                k !== "default" &&
                handleOptions[k] !== undefined &&
                !handleOptions[k](data, options[k], options));
            if (keysWithError.length === 0) {
                return {
                    valid: true,
                    data: transformedData,
                    errors: [],
                };
            }
            return {
                valid: false,
                data: undefined,
                errors: keysWithError.map(k => ({
                    message: `vality.${name}.options.${k}`,
                    options,
                    path,
                    value,
                })),
            };
        };
    }
    return Object.assign((options) => {
        return {
            [symbols_1._validate]: (val, path, parent) => {
                if (typeof options === "function")
                    options = options(parent);
                return getFnWithErrors(Object.assign(Object.assign({}, defaultOptions), options))(val, path);
            },
            [symbols_1._type]: undefined,
        };
    }, {
        [symbols_1._validate]: getFnWithErrors(defaultOptions),
        [symbols_1._type]: undefined,
    });
}
exports.guard = guard;
