import { Guard } from "./guard";
import { RelationType } from "./parse";
import { Primitive, RSE } from "./utils";
import { Valit } from "./valit";
declare global {
    namespace vality {
        interface guards {
            string: Guard<string, {
                minLength: number;
                maxLength: number;
                match: RegExp;
            }>;
            number: Guard<number, {
                min: number;
                max: number;
                integer: boolean;
                unsafe: boolean;
            }>;
            boolean: Guard<boolean>;
            date: Guard<Date, {
                min: Date;
                max: Date;
                past: boolean;
                future: boolean;
            }>;
            literal<P extends Primitive>(lit: P): Guard<P, {
                default: boolean;
            }>;
            relation<S extends () => RSE>(model: S): Valit<S, {
                transform: (v: RelationType) => RelationType;
            }>;
        }
    }
}
