import { Guard } from "./guard";
import { Validate, ValidateFn } from "./validate";
import type { Valit, Valitate } from "./valit";
export declare type RSA = Record<string, any>;
export declare type RSN = Record<string, never>;
export declare type RSE = {
    [K: string]: Eny;
};
export declare type MaybeArray<T> = T | T[];
export declare type Primitive = string | number | boolean | null;
export declare type _Eny = Primitive | Guard<Primitive, RSA> | Valitate<Primitive> | (() => RSE) | RSE;
export declare type Eny = MaybeArray<_Eny> | Readonly<MaybeArray<_Eny>>;
export declare type MakeRequired<T extends RSA, K extends keyof T> = {
    [key in K]-?: T[key];
} & {
    [key in Exclude<keyof T, K>]: T[key];
};
export declare function assert<T>(val: any, condition?: boolean): asserts val is T;
export declare function isValid<Type>(data: Type | undefined): data is Type;
export declare type EnyToGuard<T> = T extends [infer U] ? Valit<U[], any> : T extends [...infer U] ? Valit<U, any> : T extends Primitive ? Guard<T> : T extends Validate<any> ? T : T extends () => infer U ? Guard<U> : Valit<T, any>;
export declare function enyToGuard<E extends Eny>(eny: E): EnyToGuard<E>;
export declare function enyToGuardFn<E extends Eny>(e: E): ValidateFn<any>;
export declare function flat<T>(arr: T[][]): T[];
export declare type IdentityFn<T> = (x: T) => T;
export declare function identity<T>(x: T): T;
export declare function trueFn(..._args: any[]): true;
export declare function falseFn(..._args: any[]): false;
