import { _readonly, _valit } from "./symbols";
import { MakeRequired, RSA, RSN } from "./utils";
import type { Path, Validate, ValidationResult } from "./validate";
export declare type Valitate<V> = {
    [_valit]?: true;
} & Validate<V>;
export declare type Valit<V, Options extends RSA = RSN> = Valitate<V> & ((options: Partial<Options>) => Valitate<V>);
export declare type ValitOptions<Name extends keyof vality.valits, Fn = vality.valits[Name]> = Fn extends (...args: infer Args) => Valit<infer Type, infer Options> ? [Args, Type, Options] : never;
export declare type ReadonlyValit<T> = {
    [_readonly]?: true;
} & Valit<T>;
export declare function valit<Name extends keyof vality.valits, Arg extends ValitOptions<Name>[0], Type extends ValitOptions<Name>[1], Options extends RSA & ValitOptions<Name>[2]>(name: Name, fn: (...args: Arg) => (val: unknown, path: Path, options: Partial<Options>) => ValidationResult<Type>, handleOptions?: {
    [K in keyof Options]?: (val: Type, o: NonNullable<Options[K]>, options: MakeRequired<Options, K>) => boolean;
}, defaultOptions?: Partial<Options>): (...args: Arg) => Valit<Type, Options>;
