"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.valit = void 0;
const symbols_1 = require("./symbols");
const utils_1 = require("./utils");
function valit(name, fn, handleOptions, defaultOptions = {}) {
    return (...args) => {
        const fnWithValit = (val, path = []) => {
            return fn(...args)(val, path, defaultOptions !== null && defaultOptions !== void 0 ? defaultOptions : {});
        };
        return Object.assign((options) => {
            const fnWithValitWithOptions = (value, path = []) => {
                const data = fn(...args)(value, path, Object.assign(Object.assign({}, defaultOptions), options));
                if (!data.valid)
                    return data;
                if (handleOptions === undefined)
                    return data;
                (0, utils_1.assert)(value);
                const keysWithError = Object.keys(options).filter(k => handleOptions[k] !== undefined && !handleOptions[k](value, options[k], options));
                if (keysWithError.length === 0)
                    return data;
                return {
                    valid: false,
                    data: undefined,
                    errors: keysWithError.map(k => ({
                        message: `vality.${name}.options.${k}`,
                        options,
                        path,
                        value,
                    })),
                };
            };
            return {
                [symbols_1._validate]: fnWithValitWithOptions,
                [symbols_1._type]: undefined,
            };
        }, {
            [symbols_1._validate]: fnWithValit,
            [symbols_1._type]: undefined,
        });
    };
}
exports.valit = valit;
